# coding=utf-8
import os
import csv
import pickle as pkl
import numpy as np
import torch
from gensim.models import word2vec
from transformers import BertTokenizer, BertModel
path = 'Testing'


def bert_read1():
    # word2id = pkl.load(open('../datagenerate/proposed/data/vocb', mode='rb'))  # Question Dictionary
    word2id_ans = pkl.load(open('../datagenerate/proposed/data/ans_dict.pkl', mode='rb'))  # Answer Dictionary
    print('all num word2id_ans:', list(word2id_ans.keys()))
    print('all num in merged word2id_question:', len(list(word2id_ans.keys())))
    # ###
    tokenizer = BertTokenizer.from_pretrained('bert-base-uncased')
    model = BertModel.from_pretrained('bert-base-uncased', output_hidden_states=True)  # Load Bert pre-trained model
    model.to("cpu:0")  # This machine only has CPU. If you have GPU, please change it to GPU.
    model.eval()
    all_data_embedding = np.float32(np.random.uniform(-0.25, 0.25, (len(word2id_ans), 768)))  # truncated normal distribution, initialization
    for cur_char in list(word2id_ans.keys()):  # Traverse all the word segments, each segment is directly used as the input of Bert, and the vector corresponding to the segment is output.
        cur_char = cur_char.strip().split(' ')[0].strip()
        tokenized_text = tokenizer.tokenize(cur_char)
        indexed_tokens = tokenizer.convert_tokens_to_ids(tokenized_text)  # Get the index of each word in the vocabulary
        segments_ids = [1] * len(tokenized_text)  # participle index
        tokens_tensor = torch.tensor([indexed_tokens]).to("cpu:0")
        segments_tensors = torch.tensor([segments_ids]).to("cpu:0")

        try:
            with torch.no_grad():
                outputs = model(tokens_tensor, segments_tensors)
                hidden_states = outputs[2]

            token_embeddings = torch.stack(hidden_states, dim=0)
            token_embeddings.size()
            token_embeddings = torch.squeeze(token_embeddings, dim=1)
            token_embeddings.size()
            token_embeddings = token_embeddings.permute(1, 0, 2)  # Reverse the order
            token_embeddings.size()  # Perform three superpositions to meet Bert's input requirements.
            token_vecs_sum = [torch.sum(layer[-4:], 0) for layer in
                              token_embeddings]  # Sum the last four levels [number_of_tokens, 768]
            print('shape of token_vecs_sum:', word2id_ans[cur_char], cur_char, token_vecs_sum[-1].shape)
            all_data_embedding[word2id_ans[cur_char]] = token_vecs_sum[-1].numpy()  # Get a 768-dimensional vector, replace the normal initialization vector
        except Exception as ex:
            print('Qwer')
            pass
    pkl.dump(all_data_embedding, open('ans_bert_embedding.pkl', mode='wb'))


if __name__ == "__main__":
    # create_data()
    # vec_train()
    # init_word_embedding()
    # bert_read()
    bert_read1()
    pass