import pickle as pkl


class Config:
    def __init__(self):
        """
        Configuration file
        """
        self.seta = 1.1
        self.beta = 1.5
        self.epoch = 200
        self.get_clip = 10.
        self.batch_size = 32
        # self.batch_size = 1
        self.repost = 21
        self.learning_rate = 0.001
        self.keep_dropout = .5
        self.optimizer = 'Adam'
        self.shuffle = True
        self.sequence_length = 80
        self.embedding_size = 128
        self.get_embedding_dim = 128
        self.iter_routing = 3  # Number of routing layers of capsule network
        self.update_embedding = True  # Update mapping during training
        self.hidden_units = 64
        self.model_saved_path = '../model_save/'
        self.logging_file_saved_path = '../logs/'
        #


class DataProcessConfig:
    def __init__(self):
        self.content_length = 21

    @property
    def content_len(self):
        return self.content_length
