# coding=utf-8
import json
import pickle as pkl


class DataProcess:
    def __init__(self):
        pass

    def data_read(self, data_path, data_save_path, vocab_path=None):
        data = json.load(open(data_path, mode='r', encoding='utf-8'))  
        data_save = open(data_save_path, mode='wb')  
        qa = []
        question_vocab = dict() 
        for tmp_data in data:
            question = tmp_data['Question'].strip().replace('\n', '')  
            answer = tmp_data['Answer']  
            answer_all = []
            if len(answer) > 0:
                for k in answer:
                    # if 'WikidataLabel' in k:
                    if k['AnswerType'].__eq__('Entity'):  # Entity answer
                        answer_all.append(k['WikidataQid'])  
                    elif k['AnswerType'].__eq__('Value'):  # non-entity answer
                        answer_all.append(k['AnswerArgument'])  
                    else:
                        pass  # Other answers
                if len(answer_all) > 0:  # Filter out unanswered questions
                    qa.append([question, answer_all])  # form a record
                    # vocab
                    question_split = question.split(' ')  # Question segmentation, making question dictionary
                    for cur_word in question_split:
                        cur_word = cur_word.lower()  # Word segmentation is unified in lowercase to reduce the number of word vectors
                        if cur_word not in question_vocab.keys():  
                            question_vocab[cur_word] = len(question_vocab)

        pkl.dump(qa, data_save)
        if vocab_path is not None:  
            question_word_save = open(vocab_path, mode='wb')
            pkl.dump(question_vocab, question_word_save)  
            print('word num:', len(question_vocab.keys()))
            print('all word:', list(question_vocab.keys()))


if __name__ == "__main__":
    f = DataProcess()
    # train.json: Original file
    f.data_read('../../Source/train.json', '../../processed/train.pkl', '../../processed/question_vocab.pkl')
    f.data_read('../../Source/test.json', '../../processed/test.pkl')
    f.data_read('../../Source/dev.json', '../../processed/dev.pkl')