# coding=utf-8
import re
import csv
import json
import pickle
import openpyxl


class DataParse:
    def __init__(self, train_data_path, task2id_id2task_path, sentence_task_path, vocb_path):

        self.train_data_path = train_data_path  # training data path
        self.task2id_id2task = task2id_id2task_path  # Task mapping
        self.sentence_task_path = sentence_task_path  # training data
        self.vocb_path = vocb_path  # dictionary
        self.stop = ['”', '“', '、', '。', '，', '──', '……', '（', '）', '？', '《', '》', '<', '>',
                     '！', '......', '.', ',', '；', ';', '%']

    @property
    def stopwords(self):
        return self.stop

    def read_corpus(self, corpus_path=None, save=True):

        # if corpus_path is None:
        #     assert 'path empty'
        try:
            task_sentense = []
            task2id_id2task = {'task2id': {}, 'id2task': {}}
            skip_title = True
            lines = open(corpus_path, mode='r', encoding='utf-8', errors='ignore').readlines()
            indedx_all = 0
            for line in lines:
                if skip_title:
                    skip_title = False
                else:
                    indedx_all += 1
                    if indedx_all >= 65000:
                        print('indedx_all:', indedx_all)
                        break
                    else:
                        line = line.strip().split("\t")
                        sent = line[0].strip().lower()
                        sent_relation = line[1].strip().lower().split(',')[0]
                        sent = sent.split(' ')
                        task_sentense.append((sent, sent_relation))  # Question-Answer. if there is more than 1 answer, other answers will not be considered
                        print((sent, sent_relation))
                        if sent_relation not in task2id_id2task["task2id"].keys():  # Only the first answer is considered, including both entity answers and non-entity answers.
                            task2id_id2task["task2id"][sent_relation] = len(task2id_id2task["task2id"])
                            task2id_id2task["id2task"][len(task2id_id2task["id2task"])] = sent_relation

            if save:
                pickle.dump(task_sentense, open(self.sentence_task_path, mode='wb'))  # Save question-first answer tuple.
                pickle.dump(task2id_id2task, open(self.task2id_id2task, mode='wb'))  # Save a dictionary consisting of the first answer.
            return task_sentense, task2id_id2task
        except Exception:
            raise Exception

    def creat_vocab(self, data=None, save=True):
        # if not os.path.exists(self.vocb_path):
        if True:
            vocab = dict()  # Create dictionary
            vocab['<UNK>'] = 1  # unknown vocabulary
            vocab['<PAD>'] = 0  # tags that need to be populated
            if data is not None:
                assert isinstance(data, list) and isinstance(data[0], tuple)
                for task_sentence in data:  # Create a dictionary of questions
                    print('task_sentence[0]:', task_sentence[0])
                    for cut_word in task_sentence[0]:  # task_sentence[0] is the question segmentation
                        if cut_word not in vocab.keys():
                            vocab[cut_word] = len(vocab)
                if save:
                    print('vocab:', vocab)
                    pickle.dump(vocab, open(self.vocb_path, mode='wb'))  # Save problem node
                return vocab
            else:
                print('data empty......')
        else:
            sys.stdout.write('vocab exists......')
            return pickle.load(open(self.vocb_path, mode='rb'))


if __name__ == '__main__':

    # so = DataParse(train_data_path=r'../datagenerate/proposed/processed/test_labeled_relation_data.txt',
    #                task2id_id2task_path='../datagenerate/proposed/data/task2id_id2task',
    #                sentence_task_path='../datagenerate/proposed/data/sentence_task_test',
    #                vocb_path='../datagenerate/proposed/data/vocb')
    # so.read_corpus(so.train_data_path, False)
    # so.read_corpus(so.train_data_path, True)
    # row_datas = pickle.load(open(so.sentence_task_path, mode='rb'))
    # so.creat_vocab(row_datas)

    # q511684
    pass